#include "..\Common\type.h"
#define PIN_PW0		8
#define PORT_PW0	0

#define PIN_PW1		9
#define PORT_PW1	0

#define PIN_PW2		10
#define PORT_PW2	0

#define PIN_PW3		1
#define PORT_PW3	1

#define PIN_PW4		2
#define PORT_PW4	1

#define PIN_PW5		3
#define PORT_PW5	1

#define PIN_PW6		9
#define PORT_PW6	1

#define PIN_PW7		10
#define PORT_PW7	1

#define PWM1 0
#define PWM2 1
#define PWM3 2
#define PWM4 3
#define PWM5 4
#define PWM6 5
#define PWM7 6
#define PWM8 7

#define PWM_DEFAULT_FREQ_KHz 1
#define PWM_DEFAULT_FREQ_Hz (PWM_DEFAULT_FREQ_KHz*1000)
#define PWM_DEFAULT_PULSE 0 //microsecond
#define MAX_PWM	8

typedef enum {MAT0 = 0, MAT1=1, MAT2=2} PWM_MATCH;
typedef enum {CT16 = 0, CT32=1} PWM_CT;
typedef enum {TIMER0 = 0, TIMER1=1} PWM_TIMER;
typedef struct {                        /* Search info record                */
  BYTE port;
  BYTE pin;
	PWM_MATCH mat;
	PWM_TIMER timer_num;
	PWM_CT ct;
} PWM;

// void Set_CT16_PWM_Frequency(uint16_t frequency);
// void Set_CT32_PWM_Frequency(uint16_t frequency);
// uint16_t Get_CT16_PWM_Frequency(void);
// uint16_t Get_CT32_PWM_Frequency(void);
// void Set_PWM_Frequency_Default(void);;
// void SetPWM(BYTE pwm_index, BYTE dutycycle);
void InitalizePWM(void);
void UpdatePWM(UINT32 new_period,UINT32  *pulse);
// void SetPWM(BYTE pwm_index, uint16_t dutycycle);
void SetPulse(BYTE pwm_index, uint32_t pulse_microsecond);


